                                                                                     /*
Ŀ
  Program Name: TEST.PRG          Copyright: Gallagher Computing Corp. 
  Date Created: 08/11/92           Language: Clipper 5.0               
  Time Created: 00:39:14             Author: Kevin S Gallagher  .PRG   
  c:/brief/clipper.src               Author: Ben Echols         .ASM   
  What it does: Places a clock on the display screen.                                                       
  Files needed: TICKER.OBJ                                                       
  RETURN CODES:                                                        
  - 100     successful                                                 
  -  99     col out of range                                           
  -  98     row out of range                                           
  -  97     already installed / not installed                          
                                                                       
 LIMITATIONS:                                                          
 NONE                                                                  
 Kevin S. Gallagher   660 Woodward Drive  Huntingdon Vlly. PA 19006    
 CIS: 70034,2313                                                       

             */

function testclock
    local x
    scroll()
    @0,0 say PADR(" ",80) color 'w+/rb'
    @MAXROW(),0 say PADR(" PRESS ANY KEY TO EXIT...",80) color "W+/RB"
    CLOCK(0,71)                                // install clock
    inkey(0)
    x := CLOCK()                                // remove and get errorlevel
    @ maxrow(),0 say PADR(" Clock returned "+ltrim(str(x)),80) color "W+/RB"
return nil

//////////////////////////////////////////////////////////////////////////
// Syntax:  BK_TICKINS(<nRow>,<nCol>) --> nErrorLevel
//          Where <nRow> is the row to position the clock   0 - 24
//                <nCol> is the column to place the clock   0 - 72
//
//          BK_TICKREM() -->nErrorLevel
//          Used to remove the clock
//
// Returns:  100 if successful
//            99 column out of range
//            98 Row out of range
//            97 Already installed/not installed
//
// The function below is one of many ways to invoke the clock, use whatever
// method you like to use!
//
//////////////////////////////////////////////////////////////////////////
function CLOCK(nRow,nCol)
    local x:=IF(nRow==NIL.OR.nCol==NIL,BK_TICKREM(),BK_TICKINS(nRow, nCol))
return x

