/***
*       Inkey.ch
*       Standard INKEY() key-code definitions
*       Copyright (c) 1990-1991 Nantucket Corp.  All rights reserved.
*       Revised by Jason Massey from p to p
*/

// Cursor movement keys
#define pUP            5       // Uparrow, Ctrl-E
#define pDOWN          24      // Dnarrow, Ctrl-X
#define pLEFT          19      // Leftarrow, Ctrl-S
#define pRIGHT         4       // Rightarrow, Ctrl-D
#define pHOME          1       // Home, Ctrl-A
#define pEND           6       // End, Ctrl-F
#define pPGUP          18      // PgUp, Ctrl-R
#define pPGDN          3       // PgDn, Ctrl-C
#define pCTRL_LEFT     26      // Ctrl-Leftarrow, Ctrl-Z
#define pCTRL_RIGHT    2       // Ctrl-Rightarrow, Ctrl-B
#define pCTRL_HOME     29      // Ctrl-Home, Ctrl-]
#define pCTRL_END      23      // Ctrl-End, Ctrl-W
#define pCTRL_PGUP     31      // Ctrl-PgUp, Ctrl-Hyphen
#define pCTRL_PGDN     30      // Ctrl-PgDn, Ctrl-^
#define pCTRL_RET      10      // Ctrl-Return

#define pESC           27      // Esc, Ctrl-[
#define pRETURN        13      // Return, Ctrl-M
#define pENTER         13      // Enter, Ctrl-M


// Editing keys
#define pINS           22      // Ins, Ctrl-V
#define pDEL           7       // Del, Ctrl-G
#define pBS            8       // Backspace, Ctrl-H
#define pCTRL_BS       127     // Ctrl-Backspace
#define pTAB           9       // Tab, Ctrl-I
#define pSH_TAB        271     // Shift-Tab


// Control keys
#define pCTRL_A        1       // Ctrl-A, Home
#define pCTRL_B        2       // Ctrl-B, Ctrl-Rightarrow
#define pCTRL_C        3       // Ctrl-C, PgDn, Ctrl-ScrollLock
#define pCTRL_D        4       // Ctrl-D, Rightarrow
#define pCTRL_E        5       // Ctrl-E, Uparrow
#define pCTRL_F        6       // Ctrl-F, End
#define pCTRL_G        7       // Ctrl-G, Del
#define pCTRL_H        8       // Ctrl-H, Backspace
#define pCTRL_I        9       // Ctrl-I, Tab
#define pCTRL_J        10      // Ctrl-J
#define pCTRL_K        11      // Ctrl-K
#define pCTRL_L        12      // Ctrl-L
#define pCTRL_M        13      // Ctrl-M, Return
#define pCTRL_N        14      // Ctrl-N
#define pCTRL_O        15      // Ctrl-O
#define pCTRL_P        16      // Ctrl-P
#define pCTRL_Q        17      // Ctrl-Q
#define pCTRL_R        18      // Ctrl-R, PgUp
#define pCTRL_S        19      // Ctrl-S, Leftarrow
#define pCTRL_T        20      // Ctrl-T
#define pCTRL_U        21      // Ctrl-U
#define pCTRL_V        22      // Ctrl-V, Ins
#define pCTRL_W        23      // Ctrl-W, Ctrl-End
#define pCTRL_X        24      // Ctrl-X, Dnarrow
#define pCTRL_Y        25      // Ctrl-Y
#define pCTRL_Z        26      // Ctrl-Z, Ctrl-Leftarrow


// Alt keys
#define pALT_A         286     // Alt-A
#define pALT_B         304     // Alt-B
#define pALT_C         302     // Alt-C
#define pALT_D         288     // Alt-D
#define pALT_E         274     // Alt-E
#define pALT_F         289     // Alt-F
#define pALT_G         290     // Alt-G
#define pALT_H         291     // Alt-H
#define pALT_I         279     // Alt-I
#define pALT_J         292     // Alt-J
#define pALT_K         293     // Alt-K
#define pALT_L         294     // Alt-L
#define pALT_M         306     // Alt-M
#define pALT_N         305     // Alt-N
#define pALT_O         280     // Alt-O
#define pALT_P         281     // Alt-P
#define pALT_Q         272     // Alt-Q
#define pALT_R         275     // Alt-R
#define pALT_S         287     // Alt-S
#define pALT_T         276     // Alt-T
#define pALT_U         278     // Alt-U
#define pALT_V         303     // Alt-V
#define pALT_W         273     // Alt-W
#define pALT_X         301     // Alt-X
#define pALT_Y         277     // Alt-Y
#define pALT_Z         300     // Alt-Z
#define pALT_1         376     // Alt-1
#define pALT_2         377     // Alt-2
#define pALT_3         378     // Alt-3
#define pALT_4         379     // Alt-4
#define pALT_5         380     // Alt-5
#define pALT_6         381     // Alt-6
#define pALT_7         382     // Alt-7
#define pALT_8         383     // Alt-8
#define pALT_9         384     // Alt-9
#define pALT_0         385     // Alt-0

// Function keys
#define pF1            28      // F1, Ctrl-\
#define pF2            -1      // F2
#define pF3            -2      // F3
#define pF4            -3      // F4
#define pF5            -4      // F5
#define pF6            -5      // F6
#define pF7            -6      // F7
#define pF8            -7      // F8
#define pF9            -8      // F9
#define pF10           -9      // F10
#define pF11           -40     // F11
#define pF12           -41     // F12

// Control-function keys
#define pCTRL_F1       -20     // Ctrl-F1
#define pCTRL_F2       -21     // Ctrl-F2
#define pCTRL_F3       -22     // Ctrl-F4
#define pCTRL_F4       -23     // Ctrl-F3
#define pCTRL_F5       -24     // Ctrl-F5
#define pCTRL_F6       -25     // Ctrl-F6
#define pCTRL_F7       -26     // Ctrl-F7
#define pCTRL_F8       -27     // Ctrl-F8
#define pCTRL_F9       -28     // Ctrl-F9
#define pCTRL_F10      -29     // Ctrl-F10
#define pCTRL_F11      -44     // Ctrl-F11
#define pCTRL_F12      -45     // Ctrl-F12

// Alt-function keys
#define pALT_F1        -30     // Alt-F1
#define pALT_F2        -31     // Alt-F2
#define pALT_F3        -32     // Alt-F3
#define pALT_F4        -33     // Alt-F4
#define pALT_F5        -34     // Alt-F5
#define pALT_F6        -35     // Alt-F6
#define pALT_F7        -36     // Alt-F7
#define pALT_F8        -37     // Alt-F8
#define pALT_F9        -38     // Alt-F9
#define pALT_F10       -39     // Alt-F10
#define pALT_F11       -46     // Alt-F11
#define pALT_F12       -47     // Alt-F12

// Shift-function keys
#define pSH_F1         -10     // Shift-F1
#define pSH_F2         -11     // Shift-F2
#define pSH_F3         -12     // Shift-F3
#define pSH_F4         -13     // Shift-F4
#define pSH_F5         -14     // Shift-F5
#define pSH_F6         -15     // Shift-F6
#define pSH_F7         -16     // Shift-F7
#define pSH_F8         -17     // Shift-F8
#define pSH_F9         -18     // Shift-F9
#define pSH_F10        -19     // Shift-F10
#define pSH_F11        -42     // Shift-F11
#define pSH_F12        -43     // Shift-F12

