* TBEdit.prg
* Jason Massey (510)748-0159 Compuserve ID# 70363,2703

#include "inkey.ch"
/*
* TBEdit (<TOP>,<LEFT>,<BOTTOM>,<RIGHT>,<aFIELDS>,<aPICTURE>,<aHEADERS>,<bFILTER>,<lEDITMODE>)                               
*
* This function is intended to be a template for DBEDIT.  I put together this
* function from several different sources.  Greg Lief wrote and article in 
* Reference(CLIPPER), April '91 p.4 that used a FieldBlock() routine to edit
* Browse objects.  Unfortunately his module only worked on Character type
* fields.  Additionally, Paul Sheriff wrote an article in Reference(CLIPPER)
* in May '91 p.16 that created a while loop within the TBrowse object.  This
* approach was far superior than 'Set Filter To'.  I've found that filters
* can take as long as 10 minutes to set under network conditions, even if
* your database has as few as 3000 records.  (This was on a SCSI drive too.)
* combining their routines and a screen function I wrote, I was able to 
* duplicate DBEDIT without all the problems of navigation that dbedit had.
* The program assumes that you use LOCKS.prg (I have a substitute but didn't
* provide it here.)  Additionally, I have not provided the source code for
* my screenit function, but I have included the .obj file.  If you want the 
* source code you can contact me at (510)748-0159 or reach me on compuserve.
* NOTE:  I've also used Steven Straley's 'ineky.ch' file instead of CLIPPER.
* (I hate typing 'K_' if I can type "p").
*
* <nTop>,<nLeft>,<nBottom>,<nRight> define the Browsing window
* <aFields> is an array containing the database field names.
* <aPicture> is an array corresponding to the picture clause for each field.
* <aHeaders> is an array for headings. 
* <bFilter> is a code block expression used to filter records
*           If you don't want a filter use {||.t.} with no quotes
* <lEditmode> is a logical variable defining whether or not the browse can
*             be edited.  If .t. is passed, <ENTER> or a key stroke will 
*             allow the field to be modified.  If .f. is passed, only 
*             navigation keystrokes are accepted.
* <ESC>  exits this particular function, but all the keystrokes are available
*        in the code so you can modify them if you want.
**        Jason Massey   
**Note to Clipper Fan's (If anyone is interested in using clipper with a 
**WINDOWS 3.1 front end send me E-MAIL/CID#70363,2703)

FUNCTION TBEdit( nTop, nLeft, nBottom, nRight, aFields, aPicture , aHeaders , bFilter, lEditmode)
   LOCAL lCont:=.t.,debtgets:={}
   LOCAL nKey, nElement
   public oBrowse, oColumn ,top:=nTop , left:=nLeft 

   oBrowse := TBrowseDB(nTop, nLeft, nBottom, nRight)
   oBrowse:headSep := chr(209)
   oBrowse:colSep  := chr(179)

   
   For nCnt:=1 to LEN(aFields)   
         oColumn := TBColumnNew(nHeaders[nCnt],GetSetBlock(aFields[nCnt],aPicture[nCnt]))
         oColumn:headSep := chr(205)
         oBrowse:addColumn(oColumn)
         aadd(debtgets,.t.)      //If the field can be edited pass .t.
                                 //This allows you to selectively edit fields.
   NEXT

   oBrowse:cargo         := bFilter
   oBrowse:goBottomBlock := {||Bott_Filt(cSeek)}
   oBrowse:goTopBlock    := {||Top_Filt(cSeek)}
   oBrowse:skipBlock     := {|nCount| Skip_Filt(nCount, oBrowse:cargo)}
   
   
   DO WHILE lCont
      SETCURSOR(0)
      Dispbegin()
      WHILE !oBrowse:stabilize() ; end
      Dispend()

      IF oBrowse:hitBottom.or.eof().or.lNew
         lNew:=.f.
         TONE(550,.5)
         TONE(850,.5)
         TONE(550,.5)
         if lEditmode
            tbaddrec()
            loop
         endif
      ENDIF
      
      IF oBrowse:hitTop
         TONE(850,2)
      ENDIF

      nKey := INKEY(0)

      
      DO CASE
      CASE nKey == pUP
         oBrowse:up()
      CASE nKey == pDOWN
         oBrowse:down()
      CASE nKey == pLEFT
         oBrowse:left()
      CASE nKey == pRIGHT
         oBrowse:right()
      CASE nKey == pPGUP
         oBrowse:pageUp()
      CASE nKey == pPGDN
         oBrowse:pageDown()
      CASE nKey == pHOME
         oBrowse:home()
      CASE nKey == pEND
         oBrowse:end()
      CASE nKey == pCTRL_PGUP
         oBrowse:goTop()
      CASE nKey == pCTRL_PGDN
         oBrowse:goBottom()
      CASE nKey == pCTRL_LEFT
         oBrowse:panLeft()
      CASE nKey == pCTRL_RIGHT
         oBrowse:panRight()
      CASE nKey == pCTRL_HOME
         oBrowse:panHome()
      CASE nKey == pCTRL_END
         oBrowse:panEnd()
      CASE nKey == pESC
         EXIT
      CASE nKey == pDEL
         if lEditmode
            reclock(2)
            if level++==++level_chk
               if deleted()
                  recall
               else
                  delete
               endi
            endif
            oBrowse:refreshCurrent()
         endif
      CASE (nKey >=45.and.nKey<=122).or.nKey==13
         if debtgets[oBrowse:colpos].and.lEditmode
            RECLOCK(5)
            if level++==++level_chk
               SETCURSOR(1)
               public singleget:={}
               aadd(singleget,{"GET",row(),col(),,,,,aFields[oBrowse:colpos],aPicture[oBrowse:colpos],,,})
               if !(nKey==13)
                  keyboard CHR(nKey)
               endif
               screenit("singleget")
               setcursor(0)
            endif
            oBrowse:refreshCurrent()
         endif
      ENDCASE
      unlock
      dbskip(0)
      commit
   ENDDO
   SETCURSOR(1)
   RETURN (NIL)


FUNCTION TBADDREC()   
   add:="Y"
   row:=row()+1
   colum:=oBrowse:colpos
   @24,0 say padc("Add a record? (Y/N)   ",79)
   @24,50 get add pict "@!Y"
   read
   setcolor("w/n,w+/n")
   @ 24,0  clea to 24, 78
   setcolor("n/w+,w+/n")
   if add="Y"
      addrec(5)
      if level++==++level_chk
         set order to 0
         debt2pay->loannum := lnum
         set order to 1
         oBrowse:refreshCurrent()
         oBrowse:panHome()
         Dispbegin()
         while !oBrowse:stabilize() ; end
         Dispend()
         keyboard chr(pENTER)
      endif
   endif
retu   

      


