/*
   This method does string concatenation and is significantly faster than
   using the built in Stuff() function of clipper.  A parameter of 180-200
   caused memory corruption of the string.

   Compile with -n option
*/

Procedure Main(cLOOP_IT)
    Local i, cBuffer, iStart, iEnd, LOOP_IT:=Val(cLOOP_IT)

    cBuffer := Space(10 * LOOP_IT)
    iStart  := Seconds()

    For i := 1 To LOOP_IT
        cBuffer := InsertStr(cBuffer, Replicate('X', 10), ((10 * (i-1)) +1) )
    Next i
    iEnd := Seconds()

    Tone(300,10)
    ? 'Concatenation Method:', iEnd-iStart, ' Press any key'
    Inkey(0)

    For i := 1 To Len(cBuffer)
        If !(SubStr(cBuffer, i, 1) == 'X')
            ? 'corrupt at ', i, Asc(SubStr(cBuffer, i, 1))
        Endif
    Next i

    ? 'done checking'
Return


//>+*************************************************************************
//>N* InsertStr()
//>Q* Inserts one string into another.
//>T*
//>S* Syntax
//>T*     InsertStr(<cSource>, <cStr>, <iPos>) --> <cNewString>
//>T*
//>A* Arguments
//>T*     <cSource> is the target string
//>T*
//>T*     <cStr> is the string to be inserted
//>T*
//>T*     <iPos> is the location in <cSource> where <cStr> should be 
//>T*            inserted
//>T*
//>R* Returns
//>T*     <cNewString> is the new, modified string.
//>T*
//>D* Description
//>T*     Example:
//>T*         ? InsertStr('TEST PROGRAM', 'XYZ', 2)
//>T*               TXYZ PROGRAM
//>-*************************************************************************
Function InsertStr(cSource, cStr, iPos)
    Local cReturn

    cReturn := PadR(cSource, iPos - 1) +                              ;
               cStr +                                                 ;
               Right(cSource, Len(cSource) - iPos - Len(cStr) + 1)
Return (cReturn)
