/*
   This version calls a C function by Brian Connelly to pysically change
   individual bytes to prevent memory allocation.  This has served as a 
   work around, but the root of the problem still needs to be fixed at
   the Clipper internal level.

   The speed of this routine, as you can already guess, is significantly
   faster and prevents memory fragmentation due to string manipulation.
   Memory is only allocated for the string at the SPACE 


   Compile with -n option
   Link with INSSTR.OBJ
*/


Procedure Main(cLOOP_IT)
    Local i, cBuffer, iPos, iStart, iEnd, LOOP_IT:=Val(cLOOP_IT)

    cBuffer := Space(10 * LOOP_IT)
    iStart := Seconds()
    For i := 1 To LOOP_IT
        InsertStr(@cBuffer, Replicate('X', 10), ((10 * (i-1)) +1) )
    Next i
    iEnd := Seconds()

    Tone(300,10)
    ? 'Calling C function Method:', iEnd-iStart, ' Press any key'
    Inkey(0)

    For i := 1 To Len(cBuffer)
        If !(SubStr(cBuffer, i, 1) == 'X')
            ? 'corrupt at ', i, Asc(SubStr(cBuffer, i, 1))
        Endif
    Next i

    ? 'done checking'

Return
