******************************
*
*  NTXDEMO.PRG
*
*  Example/Tutorial using NTXControl
*
******************************

PARAMETERS l_parm
PUBLIC g_cnorm, g_cstat, g_cmsg, g_help, g_for
PRIVATE l_choice, l_done

   l_choice = 0
   l_done = .F.

   ini_set()
   ini_scrn()
   open_dbf()


   DO WHILE !l_done

      l_choice = mainmenu( l_choice )

      DO CASE
         CASE l_choice = 1
            about()
         CASE l_choice = 2
            one2many()
         CASE l_choice = 3
            bld_ntx(.F.)
         CASE l_choice = 4
            ntx_lib()
         CASE l_choice = 5
            prt_of()
         CASE l_choice = 6
            quit_ntx()
      ENDCASE

      dsp_stat( 'D', '' )
      dsp_stat( 'I', '' )

   ENDDO

RETURN


FUNCTION mainmenu
PARAMETER l_choice

   @ 3,26 TO 13,53 DOUBLE

   @  4, 27 PROMPT "  About NTXControl        "
   @  5, 27 SAY    ""
   @  6, 27 PROMPT "  WHILE clause Demo       "
   @  7, 27 PROMPT "  FOR clause Demo         "
   @  8, 27 SAY    ""
   @  9, 27 PROMPT "  NTXControl Library      "
   @ 10, 27 PROMPT "  Print Order Form        "
   @ 11, 27 SAY    ""
   @ 12, 27 PROMPT "  Quit                    "

   MENU TO l_choice

RETURN l_choice

**************************  About  **************************

FUNCTION about
   private l_wa
   l_wa = select()

   select ntx_help

   SET KEY 13 TO about_txt
   msg( "Press <Enter> for text, <ESC> to return." )
   brow_db()
   clrmsg()
   SET KEY 13 TO

   select (l_wa)
RETURN .F.

FUNCTION about_txt
   PRIVATE l_scrn

   SET KEY 13 TO

   l_scrn = savescreen( 1, 0, 21, 79 )
   msg( 'Press ESC to Continue...' )

   memoedit( ntx_help->help, 1,0,21,79, .F. )

   msg( "Press <Enter> for text, <ESC> to return." )
   restscreen( 1, 0, 21, 79, l_scrn )

   SET KEY 13 TO about_txt
RETURN .F.


***********
*
*  One to Many Relationships using NTXControl
*
***********

FUNCTION one2many
   PRIVATE handle, ok, l_scrn, s

   l_scrn = savescreen( 2, 0, 20, 79 )

   ok     = .T.
   handle = 0
   s      = 0

   SELECT channels

   dsp_stat( 'D', 'CHANNELS')

   msg( 'Press <ENTER> to Select a Channel from CHANNELS.DBF.' )

   brow_db(2,0,12,40,.F.)  && DBEDIT() of Channels database

   IF LASTKEY() = 13       && User has selected a channel

         msg( 'Building Partial Index...', .F. )

         SELECT movies
         SET INDEX TO mv_chan
         SEEK channels->channel

* Step 3: If there was a match, build an index of all the records in
*         MOVIES.DBF with a matching channel.

         IF found()
            s = seconds()
*        Step 3a: Create an empty index with NTXCRT()
*                 ok = NTXCRT(index, length, decimal, index_key)

            IF NTXCRT( "mv4ch.ntx", 4, 0, "year" )

*        Step 3c: Open the index "MV4CH.NTX" with NXTOPEN()
*                 handle = NTXOPEN( index_name )

               handle = NTXOPEN( "mv4ch.ntx" )

*        Step 3c: Add each matching records to the Index using NTXADD()
*                 ok = NTXADD(handle, key_value, record_no)
*
*                 NOTE: key_val - Must be of TYPE Character!
*
               DO WHILE (channels->channel=movies->channel) .AND. ok
                  ok = NTXADD(handle, str(year), RECNO())
                  SKIP
               ENDDO

             ENDIF
         ENDIF

*        Step 3d: After all keys are added, Close index with NTXCLOSE()
*                 ok = NTXCLOSE(handle)
         IF ok
            NTXCLOSE(handle)
         ENDIF

         s = seconds() - s

* Step 4: After building the partial index, set that index active.

         SET INDEX TO mv4ch.ntx
         dsp_stat( 'I', 'MV4CH' )

* Step 5: Display MOVIES database with UDF brow_db() ( a.k.a. "DBEDIT()" )

         msg( "All Movies on Channel "+str(channels->channel)+;
          " sorted by YEAR. ("+ltrim(str(s))+" secs)", .F.)
         brow_db(9,10,20,79)

   ENDIF

   restscreen( 2, 0, 20, 79, l_scrn )

   clrmsg()

RETURN .F.


***************
*
* Builds a Partial Index based upon some condition
*
***************

FUNCTION bld_ntx
   PRIVATE l_index, l_key, l_4cond, l_scrn, l_len, l_dec, s

   s = 0

   SELECT movies
   SET INDEX TO title
   dsp_stat( 'D', 'MOVIES')
   dsp_stat( 'I', 'TITLE' )

   l_4cond = LEFT( g_for+space(60), 60 )
   l_scrn  = savescreen( 2, 5, 18, 75 )

   @ 2,5 CLEAR TO 18,75
   @ 2,5 TO 18,75 DOUBLE

   @  4,7 SAY 'MOVIES.DBF Structure'

   @  5,7 SAY 'Name         Type   Len    Dec'
   @  6,7 SAY '----------   ----   ---    ---'
   @  7,7 SAY 'CHANNEL        N      2     0 '
   @  8,7 SAY 'TITLE          C     40     0 '
   @  9,7 SAY 'YEAR           N      4     0 '
   @ 10,7 SAY 'TYPE           C      6     0 '

   @ 12,7 SAY 'Index Name: MV4COND.NTX                '
   @ 13,7 SAY 'Index Key : CHANNEL                    '

   @ 15,7 SAY 'FOR:' GET l_4cond VALID v_cond( l_4cond )

   msg( 'Enter "FOR" condition to build the Partial Index.', .F.)

   READ

   IF LASTKEY() != 27
      msg( 'Building Partial Index...', .F. )
      s = seconds()
      ntx_for("mv4cond", "channel", 2, 0, l_4cond)
      s = seconds() - s

      dsp_stat( 'I', 'MV4COND' )
      msg( 'Records selected from MOVIES.DBF sorted by CHANNEL. ('+ltrim(str(s))+ ' secs)', .F.)

      brow_db(2,5,13,75)
      g_for = ALLTRIM( l_4cond )
   ENDIF

   restscreen( 2, 5, 18, 75, l_scrn )

   dsp_stat( 'D','' )
   dsp_stat( 'I','' )

   clrmsg()

RETURN .F.


FUNCTION prt_of
   PRIVATE l_dest, l_of, l_no, l_i, l_oc


   l_oc   = SETCOLOR()
   l_dest = "LPT1                "

   SETCOLOR( g_cmsg )

   @ 24,0 SAY "Enter Destination:" GET l_dest
   READ
   CLEAR GETS
   clrmsg()

   l_of = MEMOREAD( "order.txt" )

   IF LASTKEY() != 27
      SET CONSOLE OFF
      SET PRINTER TO &l_dest
      SET PRINT ON

      l_no = MLCOUNT( l_of, 200, 4, .F. )
      FOR l_i = 1 TO l_no
         ?? TRIM( MEMOLINE( l_of, 200, l_i, 4, .F. ) )
         ?
      NEXT
      EJECT

      SET PRINT OFF
      SET PRINTER TO
      SET CONSOLE ON
   ENDIF

   SETCOLOR( l_oc )

RETURN .F.


FUNCTION ntx_lib
   PRIVATE l_wa
   SELECT ntx_lib

   SET KEY 13 TO lib_ex
   msg( "Press <ENTER> to see example, <ESC> to return." )
   brow_db()
   clrmsg()
   SET KEY 13 TO

   SELECT (l_wa)
RETURN .T.

FUNCTION lib_ex
   PRIVATE l_scrn

   SET KEY 13 TO

   l_scrn = savescreen( 1, 0, 21, 79 )
   msg( 'Press <ESC> to Continue...' )

   memoedit( ntx_lib->example, 1,0,21,79, .F. )

   msg( "Press <ENTER> to see example, <ESC> to return." )
   restscreen( 1, 0, 21, 79, l_scrn )

   SET KEY 13 TO lib_ex
RETURN .T.


***********
*
*  ntx_for( index_name, key_exp, len_of_key, dec_of_key, for_cond )
*
*  Arguments:
*     Char - index_name
*     Char - key_exp
*     Num  - len_of_key
*     Num  - dec_of_key
*     Char - for_cond
*
*  Example of how to build an partial index with a FOR condition
*
***********

FUNCTION ntx_for
PARAMETERS l_index, l_key, l_len, l_dec, l_4cond
   PRIVATE l_h, l_subntx, l_rt, l_cnt

   l_cnt = 0
   l_rt = .F.
   l_index = TRIM(l_index) + ".NTX"           && Index name + ext expected

   IF ntxcrt( l_index, l_len, l_dec, l_key )  && Creates Index
      l_h = ntxopen( l_index )                && Opens index and returns
      l_rt = (l_h != -1)                      && handle

      DO CASE                                 && The key must be converted
         CASE TYPE( l_key ) = "N"             && to a string.
            l_key = "STR(" + l_key + ")"
         CASE TYPE( l_key ) = "D"
            l_key = "DTOS(" + l_key + ")"
      ENDCASE

      GO TOP
      DO WHILE !EOF() .AND. l_rt
         IF (&l_4cond)                               && Insert key into index
            l_rt = ntxadd( l_h, (&l_key), RECNO() )  && if FOR cond is met.
            l_cnt = l_cnt + 1
         ENDIF

         SKIP
      ENDDO

      IF l_cnt > 20
         @ 16, 7 SAY "WARNING!  Only added the first 20 keys found."
      ENDIF

      IF l_rt
         l_rt = ntxclose( l_h )              && Close the index
      ELSE
         ntxclose( l_h )
      ENDIF

      SET INDEX TO (l_index)                 && Make index active

      dsp_stat( 'I', l_index )

   ENDIF
RETURN l_rt


***********
*
*  ntx_wl( index_name, key_exp, len_of_key, dec_of_key, wl_exp )
*
*  Arguments:
*     Char - index_name
*     Char - key_exp
*     Num  - len_of_key
*     Num  - dec_of_key
*     Char - wl_exp
*
*  Example of how to build an partial index with a WHILE condition
*
***********

FUNCTION ntx_wl
PARAMETERS l_index, l_key, l_len, l_dec, l_wexp
   PRIVATE l_h, l_subntx, l_rt, l_wlexp

   l_rt = .F.
   l_index = TRIM(l_index) + ".NTX"           && Index name + ext expected

   IF ntxcrt( l_index, l_len, l_dec, l_key )  && Creates Index
      l_h = ntxopen( l_index )                && Opens index and returns
      l_rt = (l_h != -1)                      && handle

      DO CASE                                 && The key must be converted
         CASE TYPE( l_key ) = "N"             && to a string.
            l_key = "STR(" + l_key + ")"
         CASE TYPE( l_key ) = "D"
            l_key = "DTOS(" + l_key + ")"
      ENDCASE

      DO WHILE (&l_wexp) .AND. l_rt               && Evaluate while condition
         l_rt = ntxadd( l_h, (&l_key), RECNO() )  && Add keys to index
         SKIP
      ENDDO

      IF l_rt
         l_rt = ntxclose( l_h )              && Close the index
      ELSE                                   &&
         ntxclose( l_h )                     &&
      ENDIF

      SET INDEX TO (l_index)                 && Make index active

      dsp_stat( 'I', l_index)                && Display Index on Status Line

   ENDIF
RETURN l_rt


FUNCTION v_key
PARAMETERS l_key

   IF !EMPTY(l_key)
      IF TYPE(l_key) $ "CNDL"
         RETURN .T.
      ELSE
         msg( "Invalid Expression.", .T. )
      ENDIF
   ENDIF

RETURN .F.

FUNCTION v_cond
PARAMETERS l_cond

   IF !EMPTY(l_cond)
      IF TYPE(l_cond) = "L"
         RETURN .T.
      ELSE
         msg( "Invalid Expression.", .T. )
      ENDIF
   ENDIF

RETURN .F.


FUNCTION ini_set

   SET DELETED ON
   SET EXCLUSIVE ON
   SET CENTURY ON
   SET SCOREBOARD OFF

   SET KEY -9 TO save_scr()

   IF iscolor()
      g_cnorm = "w/b,b/w,,,w/b"
      g_cstat = "n/bg"
      g_cmsg   = "w/n,b/w,,,w/n"
   ELSE
      g_cnorm = "w/n,n/w,,,w/n"
      g_cstat = "n/w"
      g_cmsg   = "w/n,n/w,,,w/n"
   ENDIF

   g_help = .T.
   g_for = "YEAR = 1991"

   READINSERT(.T.)
   READEXIT(.F.)

RETURN .T.
   
FUNCTION ini_scrn
   CLEAR SCREEN
   SET COLOR TO (g_cstat)
   @ 0,0 SAY  "                        NTXContol - Partial Indexing Demo                       "
   @ 22,0 SAY "  Database:                                              Index:               "
   SET COLOR TO (g_cnorm)
RETURN .F.


FUNCTION open_dbf

   SET COLOR TO (g_cstat)

   SELECT 0
   USE ntx_lib
   SELECT 0
   USE ntx_help
*    INDEX ntx_help
   SELECT 0
   USE movies INDEX title
   SELECT 0
   USE channels

   SET COLOR TO (g_cnorm)

RETURN .F.


*******************
*
* Utility Funtions
*
*******************

FUNCTION brow_db
PARAMETERS l_r1, l_c1, l_r2, l_c2, l_rscr
   PRIVATE l_scrn

   IF (PCOUNT() < 4)
      l_r1 = 2
      l_c1 = 0
      l_r2 = 20
      l_c2 = 79
   ENDIF

   l_rscr = IIF( PCOUNT() == 5, l_rscr, .T. )

   IF l_rscr
      l_scrn = savescreen( l_r1, l_c1, l_r2, l_c2 )
   ENDIF

   @ l_r1,l_c1 TO l_r2,l_c2 DOUBLE

   dsp_stat( 'D', ALIAS() )

   dbedit( l_r1+1, l_c1+1, l_r2-1, l_c2-1, "", "dbe_func" )

   dsp_stat( 'D', '')
   dsp_stat( 'C', '')
   dsp_stat( 'I', '')

   IF l_rscr
      restscreen( l_r1, l_c1, l_r2, l_c2, l_scrn )
   ENDIF

RETURN .F.


FUNCTION dbe_func
PARAMETERS l_mode, l_fldptr

   SET COLOR TO (g_cstat)
   dsp_stat( 'C', "Record: " + ltrim(str(recno())) + " of " + ltrim(str(lastrec())) )
   SET COLOR TO (g_cnorm)

   IF l_mode = 4
      IF lastkey() = 27 .or. lastkey() = 13
         RETURN 0
      ENDIF
   ENDIF

RETURN 1


FUNCTION dsp_help
PARAMETERS l_key
   PRIVATE l_scrn, l_wa

   IF g_help
      l_scrn = savescreen( 1, 0, 21, 79 )

      l_wa = SELECT()

      SELECT ntx_help
      SEEK l_key
      msg( 'Press <ESC> to Continue...' )
      memoedit( ntx_help->help, 1,0,21,79, .F. )
      restscreen( 1, 0, 21, 79, l_scrn )
      clrmsg()

      SELECT (l_wa)
   ENDIF

RETURN .F.


FUNCTION msg
PARAMETERS l_msg, l_wait
   PRIVATE l_oc
   l_wait = IIF( PCOUNT() = 2, l_wait, .F. )

   l_oc = SETCOLOR()
   SET COLOR TO (g_cmsg)

   @ 23,0
   @ 24,0
   @ 23,0 SAY l_msg

   IF l_wait
      @ 24,30 SAY 'Press any Key to Continue.'
      inkey(0)
      @ 23,0
      @ 24,0
   ENDIF

   SET COLOR TO (l_oc)

RETURN .F.

FUNCTION clrmsg
   PRIVATE l_oc
   l_oc = SETCOLOR()
   SET COLOR TO (g_cmsg)
   @ 23,0
   @ 24,0
   SET COLOR TO (l_oc)
RETURN .F.


FUNCTION dsp_stat
PARAMETERS l_pos, l_str
   PRIVATE l_oc
   l_oc = SETCOLOR()
   SET COLOR TO (g_cstat)

   DO CASE
      CASE l_pos == 'D'
         @ 22,12 SAY LEFT( TRIM(l_str)+space(10), 10)
      CASE l_pos == 'I'
         @ 22,66 SAY LEFT( STRTRAN( l_str, '.NTX', '' )+space(14), 14 )
      CASE l_pos == 'C'
         @ 22,25 SAY LEFT( TRIM(l_str)+space(25), 25)
   ENDCASE

   SET COLOR TO (l_oc)

RETURN .F.


FUNCTION save_scr
   PRIVATE x_scr, l_file

   x_scr  = ''
   l_file = PROCNAME() + space(30)

   x_scr = SAVESCREEN( 1, 0, 21, 79 )

   clrmsg()
   @ 24,0 SAY "Enter File Name:" GET l_file
   READ
   clrmsg()

   SAVE ALL LIKE x_scr TO (l_file)

RETURN .F.


FUNCTION quit_ntx
   CLOSE ALL
   SET COLOR TO "w/n"
   CLEAR SCREEN
   ? ''
   ? ' Ŀ   '
   ? '                                                                '
   ? '   NTXDEMO                                                    '
   ? '   Released to the Public Domain on 5/10/92 by:               '
   ? '                                                              '
   ? '                      MESI                                    '
   ? '                      P.O. Box 1244                           '
   ? '                      St. Louis, MO  63022-1244               '
   ? '                                                              '
   ? '  '
   ? '     '
   ? ''
   ? ''
   QUIT
RETURN .F.
* EOF NTXDEMO.PRG
