*:*********************************************************************
*:
*:        Program: TXCLNDAR.PRG
*:
*:         System: Texas Associated Software Laser Library
*:         Author: Jose E. Lopez, Jr.
*:      Copyright (c) 1991, Texas Associated Software - Red Oak, TX
*:
*:*********************************************************************

txinit()
txorient("L")

txcolbox(01, 01, 105, 44, 1)    && DRAW CALENDAR BORDER

txcolbox(01, 01, 105, 02, 1)    && DRAW BORDER FOR MONTH NAME
_month = CMONTH(DATE())         && CHARACTER MONTH NAME
_year  = STR(YEAR(DATE()),4)    && CHARACTER YEAR
_mo_yr = _month + " " + _year
_col   = (105 - LEN(Alltrim(_mo_yr))) / 2
txcolprint(02, _col, .T., _mo_yr)

txcolprint(04, 05, .T., "Sunday")
txcolprint(04, 20, .T., "Monday")
txcolprint(04, 35, .T., "Tuesday")
txcolprint(04, 48, .T., "Wednesday")
txcolprint(04, 63, .T., "Thursday")
txcolprint(04, 80, .T., "Friday")
txcolprint(04, 94, .T., "Saturday")

DECLARE week1_[7], week2_[7], week3_[7], week4_[7], week5_[7]
FOR I = 1 TO 5
   _array = "week"+STR(INT(I),1)+"_"
   FOR i2 = 1 TO 7
      &_array[i2] = " "
   NEXT
NEXT

txcolbox(03, 01, 105, 02, 1, 10) && DRAW BORDER FOR DAYS OF WEEK

FOR I = 13 TO 103 STEP 15
   FOR X = 05 TO 40 STEP 8
      txcolbox(X, I, 03, 02, 1) && DRAW DAY OF MONTH BOX
   NEXT
NEXT

FOR I = 1 TO 105 STEP 15
   txcolbox(03, I, 15, 02, 1)   && DRAW DAY DIVIDING COLUMNS
   txcolbox(05, I, 15, 40, 1)   && DRAW DAY DIVIDING COLUMNS
NEXT

FOR I = 5 TO 40 STEP 8
   txcolbox(I, 01, 105, 8, 1)   && DRAW DAY DIVIDING ROWS
NEXT

_bom   = DAY(DATE() - DAY(DATE()) + 1)
_bdom  = DATE() - DAY(DATE()) + 1
_bndom = DOW(_bdom)

IF MONTH(DATE()) = 12           && CHECK FOR DECEMBER
   _eom = CTOD("01/01" + SUBSTR(STR(YEAR(DATE()) + 1, 4), 3, 2) - 1)
ELSE
   _eom = SUBSTR(STR(MONTH(DATE()) + 1, 2), 1, 2)
   _eom = _eom + "/01/" + SUBSTR(STR(YEAR(DATE()), 4), 3, 2)
   _ndays = DAY(CTOD(_eom) - 1)
   _deom = CTOD(_eom) - 1
ENDIF

I = 1
FOR i2 = _bndom TO 7
   week1_[i2] = STR(I, 2)
   I = I + 1
NEXT
FOR i2 = 1 TO 7
   week2_[i2] = STR(I, 2)
   I = I + 1
NEXT
FOR i2 = 1 TO 7
   week3_[i2] = STR(I, 2)
   I = I + 1
NEXT
FOR i2 = 1 TO 7
   IF I <= _ndays
      week4_[i2] = STR(I, 2)
   ENDIF
   I = I + 1
NEXT

IF I <= _ndays
   FOR i2 = 1 TO 7
      IF I <= _ndays
         week5_[i2] = STR(I, 2)
      ENDIF
      I = I + 1
   NEXT
ENDIF

IF I <= _ndays
   FOR i2 = 1 TO 7
      IF I <= _ndays
         week1_[i2] = STR(I, 2)
      ENDIF
      I = I + 1
   NEXT
ENDIF

i2 = 1
FOR I = 6 TO 42 STEP 8
   _array = "week"+STR(INT(i2),1)+"_"
   txcolprint(I, 13, .T., &_array[1])
   txcolprint(I, 28, .T., &_array[2])
   txcolprint(I, 43, .T., &_array[3])
   txcolprint(I, 58, .T., &_array[4])
   txcolprint(I, 73, .T., &_array[5])
   txcolprint(I, 88, .T., &_array[6])
   txcolprint(I,103, .T., &_array[7])
   i2 = i2 + 1
NEXT

txclear()

*: EOF: TXCLNDAR.PRG
