*:*********************************************************************
*:
*:        Program: TXINVOIC.PRG
*:
*:         System: Texas Associated Software Laser Library
*:         Author: Jose E. Lopez, Jr.
*:      Copyright (c) 1991, Texas Associated Software - Red Oak, TX
*:
*:*********************************************************************

txinit()
txreset()
txpagesize("letter")

_company   = "Texas Associated Software"
_address1  = "523 La Cresta Drive"
_address2  = "Red Oak, TX  75154"
_phone     = "(214) 617-5260"

_customer  = "Nicholas Buno"
_caddress1 = "Malcolm Pirnie, Inc."
_caddress2 = "2 Corporate Park Dr. Box 751"
_cphone    = "White Plains, NY  10602"

_invoiceno = "PH07019101"
_purchordr = "Phone Order"
_payterms  = "On Reciept"

DO txmacro                  && Define macro to print invoice form
&& and constants

txcour12r()                 && Set font to Courier 12 point 10 cpi
&& Changed with Release 1.11

FOR I = 1 TO 1
   txcolprint(03, 54, .F., _invoiceno)
   txcolprint(03, 65, .F., DTOC(DATE()))
   txcolprint(08, 58, .F., _purchordr)
   txcolprint(13, 58, .F., _payterms)

   txcolprint(14, 10, .T., _customer)
   txcolprint(15, 10, .F., _caddress1)
   txcolprint(16, 10, .F., _caddress2)
   txcolprint(17, 10, .F., _cphone)

   txcolprint(24, 10, .F., "TexAS Laser Printer Library")
   txcolprint(24, 75, .F., "4995")
   txcolprint(25, 10, .F., "Serial #1208900")
   txcolprint(52, 75, .F., "4995")
   txcolprint(60, 75, .T., "4995")

   txoverlay(1)         && Print invoice form using macro # 1 overlay
   txpsource(0)         && Print current page
NEXT

txclear()


*!*********************************************************************
*!
*!      Procedure: TXMACRO
*!
*!      Called by: TXINVOIC.PRG
*!
*!          Calls: TXMACBEGIN()   (function  in ?)
*!               : TXSETLPI()     (function  in ?)
*!               : TXLNPRT85()    (function  in ?)
*!               : TXCOLBOX()     (function  in ?)
*!               : TXGRAYBAR()    (function  in ?)
*!               : TXVPRINT()     (function  in ?)
*!               : TXDOTPRINT()   (function  in ?)
*!               : TXCOLPRINT()   (function  in ?)
*!               : TXCOUR12R()    (function  in ?)
*!               : TXMACEND()     (function  in ?)
*!
*!*********************************************************************
PROCEDURE txmacro

txmacbegin(1)        && Start Macro #1 Definition

txsetlpi(12)         && Set to print 12 lpi for vertical print
txlnprt85()          && Set font to Line Printer 8.5 point 16.67 cpi

txcolbox(01, 01, 50, 08, 1)        && Draw From Box
txgraybar(09, 03, 49, 01, 15)      && Draw Shadow under box
txgraybar(02, 51, 02, 08, 15)      && Draw Shadow right side
txcolbox(01, 55, 20, 01, 1, 20)    && Draw Invoice/Date Box Header
txcolbox(01, 55, 20, 04, 1)        && Draw Invoice/Date Box
txcolbox(01, 55, 10, 04, 1)        && Draw Invoice/Date divider
txcolbox(06, 55, 20, 04, 1)        && Draw PO Box
txcolbox(06, 55, 20, 01, 1, 20)    && Draw PO Header
txcolbox(11, 55, 20, 04, 1)        && Draw Terms Box
txcolbox(11, 55, 20, 01, 1, 20)    && Draw Terms Header
txcolbox(12, 01, 50, 08, 1, 20)    && Draw Ship To Box
txcolbox(22, 01, 79, 01, 1, 20)    && Draw Invoice Header
txcolbox(22, 71, 09, 40, 1)        && Draw Amount divider
txcolbox(22, 01, 79, 30, 1,  0, 10) && Draw Invoice Box
txcolbox(23, 78, 02, 39, 1)        && Draw Cents divider
txcolbox(52, 01, 79, 10, 1,  0, 10) && Draw Comments Box
txcolbox(52, 53, 27, 10, 1, 10)    && Draw Totals Box

txvprint(02, 01, "From")
txvprint(24, 01, "Ship To")
txvprint(108, 01, "Comments")

txsetlpi(6)

txdotprint(40, 1700, .T., "INVOICE#          DATE")
txdotprint(290, 1775, .T., "PURCHASE ORDER#")
txdotprint(540, 1800, .T., "PAYMENT TERMS")
txdotprint(1088, 900, .T., "PRODUCT OR SERVICES")
txdotprint(1088, 2200, .T., "AMOUNT")
txcolprint(52, 105, .T., "TOTAL")
txcolprint(53, 105, .T., "SALES TAX")
txcolprint(54, 105, .T., "SHIPPING")
txcolprint(55, 105, .T., "MISC")

txcour12r()                 && Set font to Courier 12 point 10 cpi

txcolprint(02, 10, .T., _company)
txcolprint(03, 10, .F., _address1)
txcolprint(04, 10, .F., _address2)
txcolprint(05, 10, .F., _phone)

FOR I = 24 TO 50 STEP 2
   txgraybar( I, 01, 79, 01, 5)
NEXT

txcolprint(60, 54, .T., "Pay This Amount")
txcolprint(53, 05, .T., "Thank you for your business")
txcolprint(55, 05, .F., "Your order supports the ShareWare concept")
txcolprint(57, 05, .F., "Include your serial# in all correspondence")

txmacend(1)        && Stop Macro #1 Definition

*: EOF: TXINVOIC.PRG
