/*********
*  QUARTER.C
*
*  by Tom Rettig
*
* Placed in the public domain by Tom Rettig Associates, 10/22/1990.
*
*  Syntax: QUARTER( <expD> )
*  Return: <expN> = quarter in which <expD> falls
*          0 if invalid parameter
*********/

#include "trlib.h"

TRTYPE quarter()
{
   char *ds;
   int quarter;
   
   if (PCOUNT == 1 && ISDATE(1) )
   {
      ds = _pards(1);

      if (!ISDS(ds))            /* not a date string */
      {
         _retni(ERROR);
         return;
      }

      /* Equation is:  quarter = ((month - 1) / 3) + 1 */
      quarter = ((DSMONTH(ds) - 1) / 3) + 1;

      _retni(quarter);
   }
   else
      _retni(ERROR);
}


