/*********
*
* SCROLLER.C
*
* by Leonard Zerman
*
* Placed in the public domain by Tom Rettig Associates, 10/22/1990.
*
*     SYNTAX:  SCROLLER(trow,tcol,brow,bcol,lines,direction)
*              direction ::= "U"|"D"
*    RETURNS:  No return value.
*
*    PURPOSE:  This program scrolls the screen up or down.  It expects
*              6 parameters:  upper-left row, upper-left column,
*              lower-right row, lower-right column, number of 
*              lines to scroll, and whether to scroll up or down.
*   
*              If it receives any invalid parameters, it will simply
*              exit without performing any action.
*********/

#include "trlib.h"

TRTYPE scroller()
{
   double d_trow;
   double d_tcol;
   double d_brow;
   double d_bcol;
   double d_lines;
   char * direction;

   if(PCOUNT == 6 && ISNUM(1) && ISNUM(2) && ISNUM(3) &&
                     ISNUM(4) && ISNUM(5) && ISCHAR(6))
   {
      d_trow    = _parnd(1);
      d_tcol    = _parnd(2);
      d_brow    = _parnd(3);
      d_bcol    = _parnd(4);
      d_lines   = _parnd(5);
      direction = _parc(6);
      _tr_scroll(&d_trow, &d_tcol, &d_brow, &d_bcol, &d_lines, direction);
   }
  _ret();
}


