/*********
*  TSTOS
*  by Tom Rettig
* Placed in the public domain by Tom Rettig Associates, 10/22/1990.
*
*  Syntax: TSTOS( <expC> )
*  Return: Numeric seconds from <expC> time string.
*          Zero if invalid time string format.
*********/

#include "trlib.h"

TRTYPE tstos()
{
   char *instr;
   long ret;
   if ( PCOUNT == 1 && ISCHAR(1) )
   {
      instr = _parc(1);
      if ( VALIDTIME(instr) )
      {
         ret = (long)
               ( (ADTOL(instr[HOURS])*36000) +
                 (ADTOL(instr[HOUR ])* 3600) +
                 (ADTOL(instr[MINS ])*  600) +
                 (ADTOL(instr[MIN  ])*   60) +
                 (ADTOL(instr[SECS ])*   10) +
                  ADTOL(instr[SEC  ])        );
         _retnl( ret );
      }
      else
         _retnl( (long)ERROR );
   }
   else
      _retnl( (long)ERROR );
}

