*********
* Function : GETAREA
* By : Tom Rettig
* Placed in the public domain by Tom Rettig Associates, 10/22/1990.
*********


FUNCTION GETAREA
* Syntax: GETAREA( <getarea>, <function> )
* Return: Value of <function> in <getarea>
*         <getarea> can be <expC> alias name or letter,
*                        or <expN> work-area number.
*         <function> is <expC> and must contain the parentheses, e.g.: "EOF()".
* Note..: This is useful only when <function> is work-area specific
*         such as EOF(), RECNO(), HEADER(), LASTREC(), FOUND(), etc.
PARAMETERS getarea, myfunc
MEMVAR cur_select, result
PRIVATE cur_select, result

cur_select = LTRIM(STR(SELECT()))
IF TYPE('getarea') = "N"
   getarea = LTRIM(STR(getarea))
ENDIF

SELECT &getarea
result = &myfunc
SELECT &cur_select

RETURN result
* eofunc


