* Filename......: Maint.Prg
*
* Author........: Vernon E. Six, Jr.
*
* Last Update...: Sat  10-19-1991  21:54:38
*
* Notice........: Copyright (c) 1991 by Vernon E. Six, Jr.
*                 All Rights Reserved World Wide

#include "INKEY.CH"
#include "SETCURS.CH"

FUNCTION MAINT()
*****
* Data Dictionary Maintenance Utility
*****
LOCAL n_Top


   * Some basic sets *
   SET( _SET_EXCLUSIVE,  .F. )  // Allow Multiple Users
   SET( _SET_SCOREBOARD, .F. )  // Don't show that Fugly line!!!!!!
   SET( _SET_EXACT,      .F. )  // Normal String comparison
   SET( _SET_DELETED,    .T. )  // Don't include deleted records


   * Let's get the show on the road *

   VS_InitVern("MAINT")
   VS_NewScrn()
   VS_InitHelp()
   EX_Version( "Maint - Data Dictionary Maintenance Utility v1.01.05" )
   EX_Release( "Mon  11-25-1991  14:49:58" )
   EX_Bueno()


   * Setup all the hot-keys *

   SetKey(K_F1,    {| p,l,v | VS_Help(p,l,v)    } ) // Context Sensitive Help
   SetKey(K_ALT_H, {| p,l,v | VS_MakeHlp(p,l,v) } ) // Create Help
   SetKey(K_ALT_L, {|       | VS_FakeLck()      } ) // Simulate Network Locks
   SetKey(K_F5,    {|       | PickFld()         } ) // Pick a field for index


   * Here we go... *

   BEGIN SEQUENCE

      **

      SELECT 0
      IF .NOT. VS_Use(GETE("DATADICT")+"_DictHdr",.F.,"_DictHdr")
         BREAK
      ENDIF

      IF .NOT. FILE(GETE("DATADICT")+"_DictHdr.Ntx")
         IF .NOT. VS_ShowNtx(GETE("DATADICT")+"_DictHdr","_DICTHDR->DBF_NAME","C")
            BREAK
         ENDIF
      ENDIF

      dbClearIndex()
      dbSetIndex(GETE("DATADICT")+"_DictHdr")

      **

      SELECT 0
      IF .NOT. VS_Use(GETE("DATADICT")+"_DictFld",.F.,"_DictFld")
         BREAK
      ENDIF

      IF .NOT. FILE(GETE("DATADICT")+"_DictFld.Ntx")
         IF .NOT. VS_ShowNtx(GETE("DATADICT")+"_DictFld","DBF_NAME+FIELD_NMBR","C")
            BREAK
         ENDIF
      ENDIF

      IF .NOT. FILE(GETE("DATADICT")+"_DictFl2.Ntx")
         IF .NOT. VS_ShowNtx(GETE("DATADICT")+"_DictFl2","DBF_NAME+FIELD_NAME","C")
            BREAK
         ENDIF
      ENDIF

      dbClearIndex()
      dbSetIndex(GETE("DATADICT")+"_DictFld")
      dbSetIndex(GETE("DATADICT")+"_DictFl2")

      **
      SELECT 0
      IF .NOT. VS_Use(GETE("DATADICT")+"_DictNtx",.F.,"_DictNtx")
         BREAK
      ENDIF

      IF .NOT. FILE(GETE("DATADICT")+"_DictNtx.Ntx")
         IF .NOT. VS_ShowNtx(GETE("DATADICT")+"_DictNtx","DBF_NAME+ORDER","C")
            BREAK
         ENDIF
      ENDIF

      dbClearIndex()
      dbSetIndex(GETE("DATADICT")+"_DictNtx")

      **

      VS_NewScrn()

      DO WHILE .T.

         IF EMPTY( S_DICTHDR() )
            EXIT
         ENDIF        

      ENDDO

   END SEQUENCE

   EX_Adios()

RETURN(NIL)
*** EOF: Maint() ************************************************************
            

